
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Game_teamsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_teams = await db.game_teams.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        color_label: data.color_label
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
        final_score: data.final_score
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await game_teams.setGame( data.game || null, {
            transaction,
        });
        
        await game_teams.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return game_teams;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const game_teamsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                color_label: item.color_label
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
                final_score: item.final_score
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const game_teams = await db.game_teams.bulkCreate(game_teamsData, { transaction });

        // For each item created, replace relation files
        

        return game_teams;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const game_teams = await db.game_teams.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.color_label !== undefined) updatePayload.color_label = data.color_label;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        if (data.final_score !== undefined) updatePayload.final_score = data.final_score;
        
        
        updatePayload.updatedById = currentUser.id;

        await game_teams.update(updatePayload, {transaction});

        
        
        if (data.game !== undefined) {
            await game_teams.setGame(
              
              data.game,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await game_teams.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return game_teams;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_teams = await db.game_teams.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of game_teams) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of game_teams) {
                await record.destroy({transaction});
            }
        });


        return game_teams;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const game_teams = await db.game_teams.findByPk(id, options);

        await game_teams.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await game_teams.destroy({
            transaction
        });

        return game_teams;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const game_teams = await db.game_teams.findOne(
            { where },
            { transaction },
        );

        if (!game_teams) {
            return game_teams;
        }

        const output = game_teams.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.game_team_assignments_game_team = await game_teams.getGame_team_assignments_game_team({
            transaction
        });
        
        
        
        output.game_player_stats_game_team = await game_teams.getGame_player_stats_game_team({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.game = await game_teams.getGame({
            transaction
        });
        
        
        output.organizations = await game_teams.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.games,
        as: 'game',
        
        where: filter.game ? {
          [Op.or]: [
            { id: { [Op.in]: filter.game.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.game.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'game_teams',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.color_label) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'game_teams',
                        'color_label',
                        filter.color_label,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.final_scoreRange) {
                const [start, end] = filter.final_scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    final_score: {
                    ...where.final_score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    final_score: {
                    ...where.final_score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.game_teams.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'game_teams',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.game_teams.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

